training_rails_2/config/routes.rb
TrainingRails2::Application.routes.draw do
  get "sessions/new"

  get "users/new"

  get "sign_up" => "users#new", :as => "sign_up"
  root :to => "users#new"
  get "log_in" => "sessions#new", :as => "log_in"
  get "log_out" => "sessions#destroy", :as => "log_out"
  resources :articles, :users, :products, :categories, :countries, :comments, :sessions
  
  namespace :admin do
    get "sign_up" => "users#new", :as => "sign_up"
    root :to => "articles#index"
    get "log_in" => "sessions#new", :as => "log_in"
    get "log_out" => "sessions#destroy", :as => "log_out"
    resources :articles, :users, :products, :categories, :countries, :comments, :sessions
  end
end

training_rails_2/app/models/article.rb
class Article < ActiveRecord::Base
  attr_accessible :title, :description, :rating, :user_id
  belongs_to :user
  has_many :comments, :dependent => :destroy
  scope :rating, where("rating > ?", 0)
  
  validates :title,   :presence => {:message => "You must filled title"},
                      :uniqueness => true,
                      :format => {:with => /[a-zA-Z\s]+$/}
  
  validates :description,   :presence => {:message => "You must filled title"}
  
  validates :rating,   :presence => {:message => "You must filled rating"}
  
  validates :user_id,   :presence => {:message => "You must filled user_id"}
                      
  validate :valid_title

  def valid_title
    self.errors[:title] << "Can't filled by 'nil, empty, and blank'" if (title == 'nil' || title == 'empty' || title == 'blank')
  end
                      
  def self.show_length
    where("length(description) > 100")
  end
end

training_rails_2/app/controllers/admin/articles_controller.rb
class Admin::ArticlesController < Admin::ApplicationController
  before_filter :require_admin_login, :only => [:new, :create, :edit, :update, :destroy]
  def index
    @articles = Article.all
  end

  def show
    @articles = Article.find(params[:id])
    @comments = Comment.find_all_by_article_id(params[:id])
    @comment  = Comment.new
  end
  
  def new
    @articles_add = Article.new
  end
  
  def create
    @articles_add = Article.new(params[:article])
    if @articles_add.save
        redirect_to :action => 'index'
    else
        render :action => 'new'
    end
  end
  
  def edit
    @article = Article.find(params[:id])
  end
  
  def update
          @article = Article.find(params[:id])
          if @article.update_attributes(params[:article])
             redirect_to :action => 'show', :id => @article
          else
             render :action => 'edit'
          end
  end
  
  def destroy
    Article.find(params[:id]).destroy
    redirect_to :action => 'index'
  end
end

training_rails_2/app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_filter :require_login, :only => [:new, :create, :edit, :update, :destroy]
  def index
    @articles = Article.find_all_by_user_id(session[:user_id])
  end

  def show
    @articles = Article.find(params[:id])
    @comments = Comment.find_all_by_article_id(params[:id])
    @comment  = Comment.new
  end
  
  def new
    @article = Article.new
  end
  
  def create
    @article = Article.new(params[:article])
    if @article.save
        flash[:notice] = "Success Entry to Article"
        redirect_to :action => 'index'
    else
        flash[:error] = "Failed Entry (Something Wrong)"
        render :action => 'new'
    end
  end
  
  def edit
    @article = Article.find(params[:id])
  end
  
  def update
          @article = Article.find(params[:id])
          if @article.update_attributes(params[:article])
             redirect_to :action => 'show', :id => @article
          else
             render :action => 'edit'
          end
  end
  
  def destroy
    Article.find(params[:id]).destroy
    redirect_to :action => 'index'
  end
end

training_rails_2/app/helpers/admin/articles_helper.rb
module Admin::ArticlesHelper
end

training_rails_2/app/helpers/articles_helper.rb
module ArticlesHelper
end

training_rails_2/app/views/admin/articles/edit.html.erb
<%= form_for @article do |f| %>
<table>
<tr>
	<td>Title</td>
	<td>: <%= f.text_field :title %></td>
</tr>
<tr>	   
  	<td>Rating </td>
	<td>: <%= f.text_field :rating %></td>
</tr>
<tr>
  	<td>User_id </td>
	<td>: <%= f.text_field :user_id %></td>
</tr>
<tr>	   
  	<td>Description </td>
	<td>: <%= text_area :article, :description %></td>
</tr>
<tr>	   
  	<td><%=f.submit :update %></td>
</tr>

</table>
<% end %>

training_rails_2/app/views/admin/articles/index.html.erb
<% if @articles.blank? %>
<p>There are not any articles currently in the system.</p>
<% else %>
<p>These are the current articles in our system</p>
<table>
<tr>
	<th>ID</th>
	<th>Title</th>
	<th>Description</th>
	<th>Rating</th>
	<th>User ID</th>
</tr>
<% @articles.each do |c| %>
<tr>
	<td><%= link_to c.id, {:action => 'show', :id => c.id} -%></td>
	<td><%= link_to c.title, {:action => 'show', :id => c.id} -%></td>
	<td><%= link_to c.description, {:action => 'show', :id => c.id} -%></td>
	<td><%= link_to c.rating, {:action => 'show', :id => c.id} -%></td>
	<td><%= link_to c.user_id, {:action => 'show', :id => c.id} -%></td>
	<td><i> <%= link_to 'Edit', {:action => "edit", :id => c.id} %></i></td>
	<td><i> <%= link_to "Delete", {:action => 'destroy', :id => c.id}, :method => :delete, :confirm => "Are you sure you want to delete this item?" %></i></td>
</tr>
<% end %>
</table>
<% end %>
<p><%= link_to "Add Article", {:action => 'new' }%></p>

training_rails_2/app/views/admin/articles/new.html.erb
<%= form_for @articles_add do |f| %>
<table>
<tr>
	<td>Title</td>
	<td>: <%= f.text_field :title %></td>
</tr>
<tr>	   
  	<td>Rating </td>
	<td>: <%= f.text_field :rating %></td>
</tr>
<tr>
  	<td>User_id </td>
	<td>: <%= f.text_field :user_id %></td>
</tr>
<tr>	   
  	<td>Description </td>
	<td>: <%= text_area :article, :description %></td>
</tr>
<tr>	   
  	<td><%=f.submit :create%></td>
</tr>

</table>
<% end %>

training_rails_2/app/views/admin/articles/show.html.erb
<table>
<tr>
	<td>Title</td>
	<td>: <%= @articles.title %></td>
</tr>
<tr>
	<td>Rating</td>
	<td>: <%= @articles.rating %></td>
</tr>
<tr>
	<td>Description</td>	
	<td>: <%= @articles.description %></td>
</tr>
<tr>
	<td>User ID</td>	
	<td>: <%= @articles.user_id %></td>
</tr>
<tr>
	<td><%= link_to 'Back', {:action => 'index'} %></td>
</tr>
</table>

<!--This section is to show all comments that owned by the article  -->
<div id="comments">
  <% @comments.each do |comment| %>
    <%= comment.content %><br />
  <% end %>
</div><br /><br />

<h1>Add Comment</h1>
<% unless(current_user.nil?)%> 
   <%= form_for @comment, :url => comments_path do |f| -%>
      <%= f.text_area :content %>
      <%= f.hidden_field :article_id, :value => @articles.id %>
	  <%= f.hidden_field :user_id, :value => current_user.id %>
      <%= submit_tag "Comment" %>
  <% end -%>
<% end %>